
<div class="row">
  <div class="container-fluid"><small class="label label-default" id="hashcode"></small>
    <div class="text-center">
      <h1 class="h4 text-gray-900 mb-4">Buat ajuan baru</h1>

    </div>
    <form class="user" autocomplete="off">
      <div class="form-group row">
        <div class="col-sm-6 mb-3 mb-sm-0">
          <input type="text" class="form-control form-control-user typeahead" id="barang" placeholder="Nama asset">
          <input type="hidden" value="" id="tempid">
        </div>
        <div class="col-sm-6">
          <input type="text" class="form-control form-control-user" id="jumlah" placeholder="Jumlah">
        </div>
      </div>
      <div class="form-group">
        <input type="text" class="form-control form-control-user" id="keterangan" placeholder="Keterangan">
      </div>
      <div class="form-group row">
        <div class="col-sm-3 mb-2 mb-sm-0">
          <a href="#!" class="btn btn-success btn-user btn-block" id="tambah">Tambah</a>
        </div><div class="col-sm-7"></div>
        <div class="col-sm-2"><a href="#!" class="btn btn-secondary btn-user btn-block" onclick="refreshTable()">Refresh</a></div>
      </div>
      <div class="form-group">
        <div class="table-responsive">
          <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
            <thead><tr><td width="5%">No</td><td>ID</td><td width="55%">Asset</td><td width="10%">Jumlah</td><td>Keterangan</td><td>Hapus</td></tr>
            <tbody></tbody>
          </table>
        </div>
      </div>
      <div class="col-sm-3 mb-2 mb-sm-0">
        <button onclick="ajukan()" class="btn btn-primary btn-user btn-block">Ajukan <i class="fas fa-fw fa-share"></i></button>
      </div>
  </div>
</div>
<script src="vendor/typeahead/bootstrap3-typeahead.js" />
<script type="text/javascript">

$("#hashcode").text(hashFnv32a("006",new Date().getUTCMilliseconds(),new Date().getUTCMilliseconds()));
function hashFnv32a(str, asString, seed) {
    var i, l,
        hval = (seed === undefined) ? 0x811c9dc5 : seed;

    for (i = 0, l = str.length; i < l; i++) {
        hval ^= str.charCodeAt(i);
        hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
    }
    if( asString ){
        return ("0000000" + (hval >>> 0).toString(16)).substr(-8);
    }
    return hval >>> 0;
}
$("#barang").keydown(function(){
  var typeahead = $("#barang").val()
  $.ajax({dataType:"json", url: $("#apiurl").val()+"/inventory/getSpesification/?name="+typeahead})
    .done(function(data){
        ty = []
      $.each( data, function( key, val ) {
          ty.push({id:val.asset_id, name:val.name+" ("+val.type+")"})
        });
        $(".typeahead").typeahead({
          source: ty,
          afterSelect: function (ty) {
            $("#tempid").val(ty.id);
          }
        });
  });
});
$("#tambah").click(function(){
  $.post($("#apiurl").val()+"/inventory/setTempKebutuhan",{
      kebutuhan_id:$("#hashcode").text(),
      asset_id:$("#tempid").val(),
      jumlah:$("#jumlah").val(),
      keterangan:$("#keterangan").val()
    },function(){
      refreshTable();
      $("#tempid").val("");
      $("#barang").val("");
      $("#jumlah").val("");
      $("#keterangan").val("");
  });
});

function refreshTable()
{
  $("#dataTable tbody").html("");
  $("#dataTable tbody").empty();
  $.ajax({dataType:"json", url: $("#apiurl").val()+"/inventory/getTempKebutuhan?kid="+$('#hashcode').text()}).done(function(data) {
    $.each( data, function( key, val ) {
      var markup = '<tr><td>-</td><td>'+val.kebutuhan_id+'</td><td>'+val.barang+' ('+val.barang+')</td><td>'+val.jumlah+'</td><td>'+val.keterangan+'</td><td><button onclick=hapus("'+val.id+'") class="btn btn-danger"><i class="fas fa-fw fa-trash"></i></button></td></tr>';
      $("#dataTable tbody").append(markup);
    })
  });
}
function hapus(id)
{
  $.post($("#apiurl").val()+"/inventory/deleteTempKebutuhan",{did:id},function(){
      refreshTable();
  });
}
function ajukan()
{
  var id=$("#hashcode").text();
  $.post($("#apiurl").val()+"/inventory/prosesKebutuhan",{did:id},function(){
      refreshTable();
      $("#hashcode").text(hashFnv32a("006",new Date().getUTCMilliseconds(),new Date().getUTCMilliseconds()));
  });
}
</script>
